﻿define pong_zoom = 8

init:
    image pong_ball:
        Crop((0,0,6,6), "free pong/sprite.png")
        zoom pong_zoom nearest True
    image pong_paddle:
        Crop((16,0,4,32), "free pong/sprite.png")
        zoom pong_zoom nearest True

init python:
    import pygame
    class free_pong_ball(renpy.Displayable):
        def __init__(self, image):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = 0
            self.y = 0

            self.visible = True
            self.parent = None
            self.colliding = 0

            self.x_direction = random.choice([-1,1])
            self.y_direction = random.choice([-1,1])

            self.x_velocity = random.randint(4,8)
            self.y_velocity = random.randint(4,8)
        def collision_check(self):
            if self.colliding > 0:
                self.colliding -= 1
                return
            for i in self.parent.paddles:
                if distance(self.x, i.x) < 50:
                    if distance(self.y, i.y) < 128:
                        i.x_velocity = 0
                        self.colliding = 10
                        if self.x < i.x:
                            self.x_direction = -1
                            i.x_velocity += 16
                        else:
                            self.x_direction = 1
                            i.x_velocity -= 16
                        self.x_velocity += abs(i.x_velocity)//2
                        if self.x_velocity > 20:
                            self.x_velocity = 20

                        self.y_velocity += i.y_velocity//2
                        renpy.play("free pong/hit.ogg", "sound")

                else:
                    self.colliding = False
        def render(self,width,height,st,at):
            if not self.visible:
                return renpy.Render(0,0)
            
            self.x += self.x_velocity * self.x_direction
            self.y += self.y_velocity

            if self.x_velocity > 0:
                self.x_velocity -= .01
            elif self.x_velocity < 0:
                self.x_velocity += .01
            if self.y_velocity > 0:
                self.y_velocity -= .01
            elif self.y_velocity < 0:
                self.y_velocity += .01

            # if self.x < -900:
            #     self.visible = False

            # elif self.x > 900:
            #     self.visible = False


            if self.x < -900:
                if self.x_direction < 0:
                    self.x_direction = -self.x_direction
            elif self.x > 1000:
                self.visible = False
                self.parent.goal()
            if self.y < -500:
                if self.y_velocity < 0:
                    self.y_velocity = -self.y_velocity
            elif self.y > 500:
                if self.y_velocity > 0:
                    self.y_velocity = -self.y_velocity

            self.collision_check()

            t = Transform(self.image)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x, self.y))

            renpy.redraw(self, 0)
            return rv
    class free_pong_paddle(renpy.Displayable):
        def __init__(self, image):
            super(renpy.Displayable,self).__init__()
            self.image = image
            self.x = 300
            self.y = 0

            self.visible = True
            self.parent = None
            self.is_ai = False

            self.w = 0
            self.a = 0
            self.s = 0
            self.d = 0

            self.speed = 2
            self.x_velocity = 0
            self.y_velocity = 0

        def render(self,width,height,st,at):
            if not self.visible:
                return renpy.Render(0,0)
            
            self.x_velocity += (self.a + self.d)*self.speed
            self.y_velocity += (self.w + self.s)*self.speed

            if self.x_velocity > 20:
                self.x_velocity = 20
            if self.x_velocity < -20:
                self.x_velocity = -20

            if self.y_velocity > 20:
                self.y_velocity = 20
            if self.y_velocity < -20:
                self.y_velocity = -20

            if self.x_velocity > 0:
                self.x_velocity -= 1
            elif self.x_velocity < 0:
                self.x_velocity += 1
            if self.y_velocity > 0:
                self.y_velocity -= 1
            elif self.y_velocity < 0:
                self.y_velocity += 1
            
            self.x += self.x_velocity
            self.y += self.y_velocity

            if self.x < -900:
                self.x = -900
                self.x_velocity = 0
            elif self.x > 900:
                self.x = 900
                self.x_velocity = 0
            if self.y < -500:
                self.y = -500
                self.y_velocity = 0
            elif self.y > 500:
                self.y = 500
                self.y_velocity = 0

            t = Transform(self.image)
            child_render = renpy.render(t, width, height, st, at)
            cw, ch = child_render.get_size()

            rv = renpy.Render(cw, ch)
            rv.blit(child_render, (self.x, self.y))

            renpy.redraw(self, 0)
            return rv

        def event(self, ev, x, y, st):
            if ev.type == pygame.KEYDOWN:
                if ev.key == pygame.K_a:
                    self.a = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_d:
                    self.d = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                if ev.key == pygame.K_w:
                    self.w = -1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()
                elif ev.key == pygame.K_s:
                    self.s = 1
                    renpy.redraw(self, 0)
                    raise renpy.IgnoreEvent()

            elif ev.type == pygame.KEYUP:
                if ev.key == pygame.K_a:
                    self.a = 0
                elif ev.key == pygame.K_d:
                    self.d = 0
                if ev.key == pygame.K_w:
                    self.w = 0
                elif ev.key == pygame.K_s:
                    self.s = 0
            return None

    class free_pong_class:
        def __init__(self, paddles):
            self.paddles = paddles
            self.balls = []
            self.add_ball()
        def add_ball(self):
            ball = free_pong_ball("pong_ball")
            ball.parent = self
            self.balls.append(ball)
        def goal(self):
            renpy.play("free pong/wrong.ogg", "sound")
            for i in self.balls:
                if not i.visible:
                    self.balls.remove(i)
        def multiply_balls(self):
            renpy.notify(1)
            if len(self.balls) > 4:
                return
            balls = []
            for i in self.balls:
                ball = free_pong_ball("pong_ball")
                ball.parent = self
                ball.x = i.x
                ball.y = i.y
                balls.append(ball)
            self.balls += balls


screen free_pong_screen():
    default g = free_pong_class(
        [free_pong_paddle("pong_paddle")]
    )
    add "#e0cfff"
    frame:
        align 1.0,.5 xysize 1880,1040 background "#04000a"

    for i in g.paddles:
        add i align .5,.5
    for i in g.balls:
        add i align .5,.5
    # text str(len(g.balls)) offset 100,100
    # button:
    #     text "multiply"
    #     action Function(g.multiply_balls) keysym "`"
    button:
        align .5,.5 background "#160f1f" padding 20,20
        text "Throw"
        action Function(g.add_ball)

label free_pong_example:
    call screen free_pong_screen